"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JsonTemplateEngine = void 0;
const parser_1 = require("./parser");
const translator_1 = require("./translator");
class JsonTemplateEngine {
    constructor(template) {
        this.fn = JsonTemplateEngine.compile(template);
    }
    static compile(template) {
        const parser = new parser_1.JsonTemplateParser(template);
        const translator = new translator_1.JsonTemplateTranslator(parser.parse());
        return new Function('data', 'bindings', translator.translate());
    }
    evaluate(data, bindings = {}) {
        return this.fn(data, bindings);
    }
}
exports.JsonTemplateEngine = JsonTemplateEngine;
