import { Expression, Token } from './types';
export declare class JsonTemplateParser {
    private readonly codeChars;
    private buf?;
    private idx;
    private expr?;
    constructor(template: string);
    static throwUnexpected(token: any): never;
    static throwError(token: Token, messageFormat: string, ...args: any[]): never;
    validateNoMoreTokensLeft(): void;
    static isLiteralToken(token: Token): boolean;
    parse(): Expression;
    private parseStatementsExpr;
    private parseStatementExpr;
    private parsePathConcatExpr;
    private parsePathConcatPartExpr;
    private parsePathGroupExpr;
    private parsePredicate;
    private parsePath;
    private parsePathPart;
    private parseSelector;
    private parsePosPredicate;
    private parseObjectPredicate;
    private parseLogicalORExpr;
    private parseLogicalANDExpr;
    private parseEqualityExpr;
    private parseRelationalExpr;
    private parseAdditiveExpr;
    private parseMultiplicativeExpr;
    private parsePosExpr;
    private parseUnaryExpr;
    private parseLiteralExpr;
    private parsePathVariable;
    private parseAssignmentExpr;
    private parseFunctionCallExpr;
    private parsePrimaryExpr;
    private parseFunctionExpr;
    private parseObjectExpr;
    private parseArrayExpr;
    private parseGroupExpr;
    private match;
    private matchPath;
    private matchSelector;
    private matchTokenType;
    private matchToken;
    private matchID;
    private matchEOT;
    private expectTokenType;
    private expect;
    lookahead(): Token;
    private advance;
    private lex;
    private static isDigit;
    private static isWhiteSpace;
    private static isIdStart;
    private static isIdPart;
    private static validateIDToken;
    private scanID;
    private scanString;
    private scanNumeric;
    private scanPunctuatorForDots;
    private scanPunctuatorForEquality;
    private scanPunctuatorForLogicalTokens;
    private scanSingleCharPunctuators;
    private scanPunctuator;
}
//# sourceMappingURL=parser.d.ts.map